# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetZoneHoldResult',
    'AwaitableGetZoneHoldResult',
    'get_zone_hold',
    'get_zone_hold_output',
]

@pulumi.output_type
class GetZoneHoldResult:
    """
    A collection of values returned by getZoneHold.
    """
    def __init__(__self__, hold=None, hold_after=None, id=None, include_subdomains=None, zone_id=None):
        if hold and not isinstance(hold, bool):
            raise TypeError("Expected argument 'hold' to be a bool")
        pulumi.set(__self__, "hold", hold)
        if hold_after and not isinstance(hold_after, str):
            raise TypeError("Expected argument 'hold_after' to be a str")
        pulumi.set(__self__, "hold_after", hold_after)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if include_subdomains and not isinstance(include_subdomains, str):
            raise TypeError("Expected argument 'include_subdomains' to be a str")
        pulumi.set(__self__, "include_subdomains", include_subdomains)
        if zone_id and not isinstance(zone_id, str):
            raise TypeError("Expected argument 'zone_id' to be a str")
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter
    def hold(self) -> builtins.bool:
        return pulumi.get(self, "hold")

    @property
    @pulumi.getter(name="holdAfter")
    def hold_after(self) -> builtins.str:
        return pulumi.get(self, "hold_after")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="includeSubdomains")
    def include_subdomains(self) -> builtins.str:
        return pulumi.get(self, "include_subdomains")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> builtins.str:
        """
        Identifier.
        """
        return pulumi.get(self, "zone_id")


class AwaitableGetZoneHoldResult(GetZoneHoldResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZoneHoldResult(
            hold=self.hold,
            hold_after=self.hold_after,
            id=self.id,
            include_subdomains=self.include_subdomains,
            zone_id=self.zone_id)


def get_zone_hold(zone_id: Optional[builtins.str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZoneHoldResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zone_hold = cloudflare.get_zone_hold(zone_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str zone_id: Identifier.
    """
    __args__ = dict()
    __args__['zoneId'] = zone_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZoneHold:getZoneHold', __args__, opts=opts, typ=GetZoneHoldResult).value

    return AwaitableGetZoneHoldResult(
        hold=pulumi.get(__ret__, 'hold'),
        hold_after=pulumi.get(__ret__, 'hold_after'),
        id=pulumi.get(__ret__, 'id'),
        include_subdomains=pulumi.get(__ret__, 'include_subdomains'),
        zone_id=pulumi.get(__ret__, 'zone_id'))
def get_zone_hold_output(zone_id: Optional[pulumi.Input[builtins.str]] = None,
                         opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZoneHoldResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zone_hold = cloudflare.get_zone_hold(zone_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str zone_id: Identifier.
    """
    __args__ = dict()
    __args__['zoneId'] = zone_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZoneHold:getZoneHold', __args__, opts=opts, typ=GetZoneHoldResult)
    return __ret__.apply(lambda __response__: GetZoneHoldResult(
        hold=pulumi.get(__response__, 'hold'),
        hold_after=pulumi.get(__response__, 'hold_after'),
        id=pulumi.get(__response__, 'id'),
        include_subdomains=pulumi.get(__response__, 'include_subdomains'),
        zone_id=pulumi.get(__response__, 'zone_id')))
